
/* SKELETON for env functions */
/* Program generated by Cadvanced 4.5.2  Patch level 2 */
#define XSCT_CADVANCED

#define SCT_VERSION_4_5
#include "scttypes.h"
#ifdef XINCLUDE_HS_FILE
#include "intro_to_env_sys.hs"
#endif
#ifdef XENV_INC
#include XENV_INC
#endif
#include "intro_to_env_sys.ifc"


#ifndef XNOGLOBALNODENUMBER
/*---+---------------------------------------------------------------
     xGlobalNodeNumber  extern
-------------------------------------------------------------------*/
#ifndef XENV_NODENUMBER
#define XENV_NODENUMBER return 1;
#endif

extern int xGlobalNodeNumber(void)
{
  /* Assign a unique global system Id to each SDL system in a cluster of systems. */
  XENV_NODENUMBER
}
#endif


#ifndef XNOINITENV
/*---+---------------------------------------------------------------
     xInitEnv  extern
-------------------------------------------------------------------*/
#ifndef XENV_INIT
#define XENV_INIT
#endif

extern void xInitEnv(void)
{
  /* Code to initialize your SDL-system environment may be inserted here */
  XENV_INIT

#ifdef XTRACE
  xPrintString("xInitEnv called\n");
#endif
}
#endif


#ifndef XNOCLOSEENV
/*---+---------------------------------------------------------------
     xCloseEnv  extern
-------------------------------------------------------------------*/
#ifndef XENV_CLOSE
#define XENV_CLOSE
#endif

extern void xCloseEnv(void)
{
  /* Code to bring down the environment in a controlled manner
     may be inserted here. */
  XENV_CLOSE

#ifdef XTRACE
  xPrintString("xCloseEnv called\n");
#endif
}
#endif


/*---+---------------------------------------------------------------
     Macros for xOutEnv
-------------------------------------------------------------------*/
#ifndef OUT_LOCAL_VARIABLES
#define OUT_LOCAL_VARIABLES
#endif

#ifndef IF_OUT_SIGNAL
#define IF_OUT_SIGNAL(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  if (((*SignalOut)->NameNode) == SIGNAL_NAME) {
#define END_IF_OUT_SIGNAL(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  }
#endif

#ifndef OUT_SIGNAL1
#define OUT_SIGNAL1(SIGNAL_NAME, SIGNAL_NAME_STRING)
#endif

#ifndef OUT_SIGNAL2
#define OUT_SIGNAL2(SIGNAL_NAME, SIGNAL_NAME_STRING)
#endif

#ifndef XENV_ENC
#define XENV_ENC(stmt) stmt
#endif

#ifndef XENV_OUT_START
#define XENV_OUT_START
#endif

#ifndef RELEASE_SIGNAL
#define RELEASE_SIGNAL   xReleaseSignal(SignalOut); return;
#endif


/*---+---------------------------------------------------------------
     xOutEnv  extern
-------------------------------------------------------------------*/
extern void xOutEnv( xSignalNode *SignalOut )
{
  OUT_LOCAL_VARIABLES

#ifdef XTRACE
#ifdef XIDNAMES
  char  Temp[100];
  sprintf(Temp, "xOutEnv:  %s has been received by env\n",
          (*SignalOut)->NameNode->Name );
  xPrintString(Temp);
#else
  xPrintString("xOutEnv:  One signal has been received by env\n");
#endif
#endif

  XENV_OUT_START


  /* Signals going to the env via the channel Channel_to_from_env */

    /* Signal sig_to_env */
    IF_OUT_SIGNAL(sig_to_env,"sig_to_env")
      OUT_SIGNAL1(sig_to_env,"sig_to_env")
	  /*
	   * ------------------------------------------------------- code added -------------------------
	   */
	  printf("Wow.  sig_to_env received by xOutEnv()\n");
      /*
	   * -------------------------------------------------------- to here ---------------------------
	   */
      OUT_SIGNAL2(sig_to_env,"sig_to_env")
      RELEASE_SIGNAL
    END_IF_OUT_SIGNAL(sig_to_env,"sig_to_env")
}


/*---+---------------------------------------------------------------
     Macros for xInEnv
-------------------------------------------------------------------*/
#ifndef IN_LOCAL_VARIABLES
#define IN_LOCAL_VARIABLES \
  xSignalNode SignalIn;
#endif

#ifndef IN_SIGNAL1
#define IN_SIGNAL1(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  SignalIn = xGetSignal(SIGNAL_NAME, xNotDefPId, xEnv);
#endif

#ifndef IN_SIGNAL2
#define IN_SIGNAL2(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  SDL_Output(SignalIn xSigPrioPar(xDefaultPrioSignal), (xIdNode *)0);
#endif

#ifndef IF_IN_SIGNAL
#define IF_IN_SIGNAL(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  if (TEST_IF_IN_SIGNAL(SIGNAL_NAME)) {
#define END_IF_IN_SIGNAL(SIGNAL_NAME, SIGNAL_NAME_STRING) \
  }
#endif

#ifndef TEST_IF_IN_SIGNAL
#define TEST_IF_IN_SIGNAL(SIGNAL_NAME)  0
#endif

#ifndef XENV_DEC
#define XENV_DEC(stmt) stmt
#endif

#ifndef XENV_IN_START
#define XENV_IN_START
#endif

#ifndef XENV_IN_END
#define XENV_IN_END
#endif


/*---+---------------------------------------------------------------
     xInEnv  extern
-------------------------------------------------------------------*/
#ifndef XTENV
extern void xInEnv ( SDL_Time Time_for_next_event )
#else
extern SDL_Duration xInEnv ( SDL_Time Time_for_next_event )
#endif
{
  IN_LOCAL_VARIABLES
static int count = 0;

#ifdef XTRACE
#ifndef XNOXINENVTRACE
  xPrintString( "xInEnv: Called!\n");
#endif
#endif

  XENV_IN_START

  if(!count)
  {
  /* Signals comming from the env via the channel Channel_to_from_env */

  /* Signal sig_from_env */
  //IF_IN_SIGNAL(sig_from_env,"sig_from_env")
    IN_SIGNAL1(sig_from_env,"sig_from_env")
    IN_SIGNAL2(sig_from_env,"sig_from_env")
  //END_IF_IN_SIGNAL(sig_from_env,"sig_from_env")
    count++;
  }
  XENV_IN_END

#ifdef XTENV
  return SDL_Time_Lit((xint32)0,(xint32)0);
#endif

}
